//+------------------------------------------------------------------+
//|                                         MTF_TrendStrength_v1.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    LightBlue
#property indicator_width1    2 
#property indicator_color2    Tomato
//---- input parameters
extern int     TimeFrame   =    0;
extern int     Mode        =    0; // 0-RSI method; 1-Stoch method; 2-ADX method  
extern int     Length      =   34; // Period of evaluation
extern int     Smooth      =    5; // Period of smoothing
extern int     Price       =    0; // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int     ModeMA      =    3; // Mode of Moving Average
extern double  Deviation   =   10;
  
//---- buffers
double Strength[];
double SigBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,Strength);
   SetIndexBuffer(1,SigBuffer);
   
//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1      : string TimeFrameStr="Period_M1"; break;
      case 5      : TimeFrameStr="Period_M5"; break;
      case 15     : TimeFrameStr="Period_M15"; break;
      case 30     : TimeFrameStr="Period_M30"; break;
      case 60     : TimeFrameStr="Period_H1"; break;
      case 240    : TimeFrameStr="Period_H4"; break;
      case 1440   : TimeFrameStr="Period_D1"; break;
      case 10080  : TimeFrameStr="Period_W1"; break;
      case 43200  : TimeFrameStr="Period_MN1"; break;
      default     : TimeFrameStr="Current Timeframe";
   }
     
   string short_name="MTF TrendStrength("+TimeFrameStr+","+Mode+","+Length+","+Smooth+","+ModeMA+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Trend");
   SetIndexLabel(1,"Signal");
//----
   SetIndexDrawBegin(0,Length+Smooth);
   SetIndexDrawBegin(1,Length+Smooth);
      
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   datetime TimeArray[];
   int      i,limit,y=0,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
   Strength[i] = 
   iCustom(NULL,TimeFrame,"TrendStrength_v1.1",Mode,Length,Smooth,Price,ModeMA,Deviation,0,y); 
   SigBuffer[i] = 
   iCustom(NULL,TimeFrame,"TrendStrength_v1.1",Mode,Length,Smooth,Price,ModeMA,Deviation,1,y); 
   }



//----
   
   return(0);
  }
//+------------------------------------------------------------------+